# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProjectIdExportersBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'connector_id': 'str',
        'database': 'str',
        'table': 'str',
        'database_write_mode': 'str',
        'filepath': 'str',
        'file_write_mode': 'str',
        'bucket': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'connector_id': 'connector_id',
        'database': 'database',
        'table': 'table',
        'database_write_mode': 'database_write_mode',
        'filepath': 'filepath',
        'file_write_mode': 'file_write_mode',
        'bucket': 'bucket'
    }

    def __init__(self, name=None, description=None, connector_id=None, database=None, table=None, database_write_mode=None, filepath=None, file_write_mode=None, bucket=None):  # noqa: E501
        """ProjectIdExportersBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._connector_id = None
        self._database = None
        self._table = None
        self._database_write_mode = None
        self._filepath = None
        self._file_write_mode = None
        self._bucket = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if connector_id is not None:
            self.connector_id = connector_id
        if database is not None:
            self.database = database
        if table is not None:
            self.table = table
        if database_write_mode is not None:
            self.database_write_mode = database_write_mode
        if filepath is not None:
            self.filepath = filepath
        if file_write_mode is not None:
            self.file_write_mode = file_write_mode
        if bucket is not None:
            self.bucket = bucket

    @property
    def name(self):
        """Gets the name of this ProjectIdExportersBody.  # noqa: E501


        :return: The name of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProjectIdExportersBody.


        :param name: The name of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this ProjectIdExportersBody.  # noqa: E501


        :return: The description of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ProjectIdExportersBody.


        :param description: The description of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def connector_id(self):
        """Gets the connector_id of this ProjectIdExportersBody.  # noqa: E501


        :return: The connector_id of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._connector_id

    @connector_id.setter
    def connector_id(self, connector_id):
        """Sets the connector_id of this ProjectIdExportersBody.


        :param connector_id: The connector_id of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """

        self._connector_id = connector_id

    @property
    def database(self):
        """Gets the database of this ProjectIdExportersBody.  # noqa: E501

        only if used with a database system connector  # noqa: E501

        :return: The database of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._database

    @database.setter
    def database(self, database):
        """Sets the database of this ProjectIdExportersBody.

        only if used with a database system connector  # noqa: E501

        :param database: The database of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """

        self._database = database

    @property
    def table(self):
        """Gets the table of this ProjectIdExportersBody.  # noqa: E501

        only if used with a database system connector  # noqa: E501

        :return: The table of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._table

    @table.setter
    def table(self, table):
        """Sets the table of this ProjectIdExportersBody.

        only if used with a database system connector  # noqa: E501

        :param table: The table of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """

        self._table = table

    @property
    def database_write_mode(self):
        """Gets the database_write_mode of this ProjectIdExportersBody.  # noqa: E501

        only if used with a database system connector  # noqa: E501

        :return: The database_write_mode of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._database_write_mode

    @database_write_mode.setter
    def database_write_mode(self, database_write_mode):
        """Sets the database_write_mode of this ProjectIdExportersBody.

        only if used with a database system connector  # noqa: E501

        :param database_write_mode: The database_write_mode of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["stack", "replace"]  # noqa: E501
        if database_write_mode not in allowed_values:
            raise ValueError(
                "Invalid value for `database_write_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(database_write_mode, allowed_values)
            )

        self._database_write_mode = database_write_mode

    @property
    def filepath(self):
        """Gets the filepath of this ProjectIdExportersBody.  # noqa: E501

        only if used with a file system connector  # noqa: E501

        :return: The filepath of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._filepath

    @filepath.setter
    def filepath(self, filepath):
        """Sets the filepath of this ProjectIdExportersBody.

        only if used with a file system connector  # noqa: E501

        :param filepath: The filepath of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """

        self._filepath = filepath

    @property
    def file_write_mode(self):
        """Gets the file_write_mode of this ProjectIdExportersBody.  # noqa: E501

        only if used with a file system connector  # noqa: E501

        :return: The file_write_mode of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._file_write_mode

    @file_write_mode.setter
    def file_write_mode(self, file_write_mode):
        """Sets the file_write_mode of this ProjectIdExportersBody.

        only if used with a file system connector  # noqa: E501

        :param file_write_mode: The file_write_mode of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["timestamp", "safe", "replace"]  # noqa: E501
        if file_write_mode not in allowed_values:
            raise ValueError(
                "Invalid value for `file_write_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(file_write_mode, allowed_values)
            )

        self._file_write_mode = file_write_mode

    @property
    def bucket(self):
        """Gets the bucket of this ProjectIdExportersBody.  # noqa: E501

        only if used with GCP Storage or S3  # noqa: E501

        :return: The bucket of this ProjectIdExportersBody.  # noqa: E501
        :rtype: str
        """
        return self._bucket

    @bucket.setter
    def bucket(self, bucket):
        """Sets the bucket of this ProjectIdExportersBody.

        only if used with GCP Storage or S3  # noqa: E501

        :param bucket: The bucket of this ProjectIdExportersBody.  # noqa: E501
        :type: str
        """

        self._bucket = bucket

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProjectIdExportersBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectIdExportersBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
